%define anolis_release 1
%global nmlibdir %{_prefix}/lib/NetworkManager

Name:           nvme-cli
Version:        2.11
Release:        %{anolis_release}%{?dist}
Summary:        NVMe management command line interface

License:        GPLv2
URL:            https://github.com/linux-nvme/nvme-cli
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:        99-nvme-nbft-connect.sh
Source2:        99-nvme-nbft-no-ignore-carrier.conf

BuildRequires:  meson >= 0.50.0
BuildRequires:  gcc gcc-c++
BuildRequires:  systemd-devel
BuildRequires:  systemd-rpm-macros
BuildRequires:  zlib-devel
BuildRequires:  openssl-devel

BuildRequires:  libnvme-devel >= 1.11-1
BuildRequires:  json-c-devel >= 0.13

BuildRequires:  asciidoc
BuildRequires:  xmlto

Requires:       util-linux

%description
nvme-cli provides NVM-Express user space tooling for Linux.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{name}-%{version_no_tilde}


%build
%meson -Dudevrulesdir=%{_udevrulesdir} -Dsystemddir=%{_unitdir} -Dpdc-enabled=true -Ddocs=all -Ddocs-build=true -Dhtmldir=%{_pkgdocdir}
%meson_build


%install
%meson_install
%{__install} -pm 644 README.md %{buildroot}%{_pkgdocdir}
mkdir -p $RPM_BUILD_ROOT%{nmlibdir}/dispatcher.d
mkdir -p $RPM_BUILD_ROOT%{nmlibdir}/conf.d
%{__install} -pm 755 %{SOURCE1} $RPM_BUILD_ROOT%{nmlibdir}/dispatcher.d/
%{__install} -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{nmlibdir}/conf.d/

rm -f %{buildroot}/usr/lib/dracut/dracut.conf.d/70-nvmf-autoconnect.conf
mv %{buildroot}%{_pkgdocdir}/nvme %{buildroot}%{_pkgdocdir}/html
rm -rf %{buildroot}%{_pkgdocdir}/nvme


%files
%license LICENSE
%{_sbindir}/nvme
%{_mandir}/man1/nvme*.zst
%{_datadir}/bash-completion/completions/nvme
%{_datadir}/zsh/site-functions/_nvme
%dir %{_sysconfdir}/nvme
%config(noreplace) %{_sysconfdir}/nvme/discovery.conf
%{_unitdir}/nvmefc-boot-connections.service
%{_unitdir}/nvmf-autoconnect.service
%{_unitdir}/nvmf-connect.target
%{_unitdir}/nvmf-connect@.service
%{_unitdir}/nvmf-connect-nbft.service
%{_udevrulesdir}/65-persistent-net-nbft.rules
%{_udevrulesdir}/70-nvmf-autoconnect.rules
%{_udevrulesdir}/70-nvmf-keys.rules
%{_udevrulesdir}/71-nvmf-netapp.rules
# Do not install the dracut rule yet.  See rhbz 1742764
# /usr/lib/dracut/dracut.conf.d/70-nvmf-autoconnect.conf
%{nmlibdir}/dispatcher.d/99-nvme-nbft-connect.sh
%{nmlibdir}/conf.d/99-nvme-nbft-no-ignore-carrier.conf

%files doc
%doc %{_pkgdocdir}

%post
%systemd_post nvmefc-boot-connections.service
%systemd_post nvmf-autoconnect.service
%systemd_post nvmf-connect@.service
%systemd_post nvmf-connect-nbft.service
if [ $1 -eq 1 ] || [ $1 -eq 2 ]; then
    # apply udev and systemd changes that we did
    systemctl daemon-reload
    udevadm control --reload-rules && udevadm trigger
    exit 0
fi

%preun
%systemd_preun nvmefc-boot-connections.service
%systemd_preun nvmf-autoconnect.service
%systemd_preun nvmf-connect@.service
%systemd_preun nvmf-connect-nbft.service

%postun
%systemd_postun nvmefc-boot-connections.service
%systemd_postun nvmf-autoconnect.service
%systemd_postun nvmf-connect@.service
%systemd_postun nvmf-connect-nbft.service

%changelog
* Thu Feb 27 2025 Hong Wei Qin <qhw01063182@alibaba-inc.com> - 2.11-1
- Refer to CentOS Stream nvme-cli-2.11-5 (tdawson@redhat.com)

* Tue Mar 28 2023 happy_orange <songnannan@linux.alibaba.com> - 2.3-1
- init package
